%define DATE 20070716
%define oprofile_version 0.9.3
%define oprofile_release 3bsc
Summary: System wide profiler
Name: oprofile
Version: 0.9.3
Release: %{oprofile_release}
License: GPL
Group: Development/System
#
Source0: oprofile-%{version}.tar.gz
Requires: binutils
Requires: which
#Changes for SDK 3.0 build process, use /usr/powerpc64-linux/lib/libbfd.a
Patch1: oprofile-sdk3-m4.diff

#Add profiling for code generated on the stack dynamically by runtime
Patch2: oprofile-sdk3-stackcode.diff

#Fix for opcontrol running on system with remote file system (time conflicts)
Patch3: oprofile-sdk3-opcontrol.diff

URL: http://oprofile.sf.net
ExclusiveArch: %{ix86} ia64 x86_64 ppc ppc64 s390 s390x alpha alphaev6 sparc sparc64 cell-be
#BuildPreReq: binutils-devel
#BuildPreReq: qt-devel
#BuildPreReq: libxslt
#BuildPreReq: docbook-style-xsl
#BuildPreReq: docbook-utils
#BuildPreReq: elinks
#BuildPreReq: gtk2-devel
#BuildPreReq: automake

BuildRoot: %{_tmppath}/%{name}-root

%description
oprofile is system-wide profiler that can be run in the background
to collect statistical performance profiles on all running
applications.

See the user guide or man pages for further details.

%prep
%setup -q -n %{name}-%{version}
%patch1 -p1 -b .sdk3-m4
%patch2 -p1 -b .sdk3-stackcode
%patch3 -p1 -b .sdk3-opcontrol

./autogen.sh

%build
#QTDIR=%{_libdir}/qt-3.3;     export QTDIR

CXXFLAGS="%{optflags}";     export CXXFLAGS
CFLAGS="%{optflags}";     export CFLAGS

%define _libdir /usr/lib
%define cell_target cell-be
./configure \
	--with-kernel-support \
	--with-target=%{cell_target} \
        --host=%{_host} --target=%{_target_platform} --build=%{_build} \
	--program-prefix= \
        --prefix=%{_prefix} \
        --exec-prefix=%{_exec_prefix} \
        --bindir=%{_bindir} \
        --sbindir=%{_sbindir} \
        --sysconfdir=%{_sysconfdir} \
        --datadir=%{_datadir} \
        --includedir=%{_includedir} \
        --libdir=%{_libdir} \
        --libexecdir=%{_libexecdir} \
        --localstatedir=%{_localstatedir} \
        --sharedstatedir=%{_sharedstatedir} \
        --mandir=%{_mandir} \
        --infodir=%{_infodir} \
	--with-separate-debug-dir=/usr/lib/debug \
	--enable-abi

make CFLAGS="$RPM_OPT_FLAGS"

%install
rm -rf ${RPM_BUILD_ROOT}

mkdir -p ${RPM_BUILD_ROOT}%{_bindir}
mkdir -p ${RPM_BUILD_ROOT}%{_mandir}/man1

make DESTDIR=${RPM_BUILD_ROOT} install

#the following is an ugly hack
rm -rf ${RPM_BUILD_ROOT}/usr/share/doc/oprofile
rm -rf ${RPM_BUILD_ROOT}/usr/share/mangled-name

#don't package the GUI for Cell blades, VPA is available
rm -f ${RPM_BUILD_ROOT}/usr/bin/oprof_start

%clean
rm -rf ${RPM_BUILD_ROOT}

%files
%defattr(-,root,root)
%doc doc/oprofile.html

%{_bindir}/ophelp
%{_bindir}/opimport
%{_bindir}/opannotate
%{_bindir}/opcontrol
%{_bindir}/opgprof
%{_bindir}/opreport
%{_bindir}/oprofiled
%{_bindir}/oparchive

%{_mandir}/man1/ophelp.1.gz
%{_mandir}/man1/opannotate.1.gz
%{_mandir}/man1/opcontrol.1.gz
%{_mandir}/man1/opgprof.1.gz
%{_mandir}/man1/opreport.1.gz
%{_mandir}/man1/oprofile.1.gz
%{_mandir}/man1/oparchive.1.gz
%{_mandir}/man1/opimport.1.gz

/usr/share/oprofile/i386/core/events
/usr/share/oprofile/i386/core/unit_masks
/usr/share/oprofile/i386/core_2/events
/usr/share/oprofile/i386/core_2/unit_masks
/usr/share/oprofile/mips/20K/events
/usr/share/oprofile/mips/20K/unit_masks
/usr/share/oprofile/mips/25K/events
/usr/share/oprofile/mips/25K/unit_masks
/usr/share/oprofile/mips/34K/events
/usr/share/oprofile/mips/34K/unit_masks
/usr/share/oprofile/mips/5K/events
/usr/share/oprofile/mips/5K/unit_masks
/usr/share/oprofile/ppc/7450/events
/usr/share/oprofile/ppc/7450/unit_masks
/usr/share/oprofile/ppc/e500v2/events
/usr/share/oprofile/ppc/e500v2/unit_masks
/usr/share/oprofile/ppc64/power5+/event_mappings
/usr/share/oprofile/ppc64/power5+/events
/usr/share/oprofile/ppc64/power5+/unit_masks
/usr/share/oprofile/alpha/ev4/events
/usr/share/oprofile/alpha/ev4/unit_masks
/usr/share/oprofile/alpha/ev5/events
/usr/share/oprofile/alpha/ev5/unit_masks
/usr/share/oprofile/alpha/ev6/events
/usr/share/oprofile/alpha/ev6/unit_masks
/usr/share/oprofile/alpha/ev67/events
/usr/share/oprofile/alpha/ev67/unit_masks
/usr/share/oprofile/alpha/pca56/events
/usr/share/oprofile/alpha/pca56/unit_masks
/usr/share/oprofile/arm/armv6/events
/usr/share/oprofile/arm/armv6/unit_masks
/usr/share/oprofile/arm/mpcore/events
/usr/share/oprofile/arm/mpcore/unit_masks
/usr/share/oprofile/arm/xscale1/events
/usr/share/oprofile/arm/xscale1/unit_masks
/usr/share/oprofile/arm/xscale2/events
/usr/share/oprofile/arm/xscale2/unit_masks
/usr/share/oprofile/i386/athlon/events
/usr/share/oprofile/i386/athlon/unit_masks
/usr/share/oprofile/i386/p4-ht/events
/usr/share/oprofile/i386/p4-ht/unit_masks
/usr/share/oprofile/i386/p4/events
/usr/share/oprofile/i386/p4/unit_masks
/usr/share/oprofile/i386/p6_mobile/events
/usr/share/oprofile/i386/p6_mobile/unit_masks
/usr/share/oprofile/i386/pii/events
/usr/share/oprofile/i386/pii/unit_masks
/usr/share/oprofile/i386/piii/events
/usr/share/oprofile/i386/piii/unit_masks
/usr/share/oprofile/i386/ppro/events
/usr/share/oprofile/i386/ppro/unit_masks
/usr/share/oprofile/ia64/ia64/events
/usr/share/oprofile/ia64/ia64/unit_masks
/usr/share/oprofile/ia64/itanium/events
/usr/share/oprofile/ia64/itanium/unit_masks
/usr/share/oprofile/ia64/itanium2/events
/usr/share/oprofile/ia64/itanium2/unit_masks
/usr/share/oprofile/rtc/events
/usr/share/oprofile/rtc/unit_masks
/usr/share/oprofile/stl.pat
/usr/share/oprofile/x86-64/hammer/events
/usr/share/oprofile/x86-64/hammer/unit_masks
/usr/share/oprofile/x86-64/family10/events
/usr/share/oprofile/x86-64/family10/unit_masks
/usr/share/oprofile/ppc64/power4/event_mappings
/usr/share/oprofile/ppc64/power4/events
/usr/share/oprofile/ppc64/power4/unit_masks
/usr/share/oprofile/ppc64/power5/event_mappings
/usr/share/oprofile/ppc64/power5/events
/usr/share/oprofile/ppc64/power5/unit_masks
/usr/share/oprofile/ppc64/power6/event_mappings
/usr/share/oprofile/ppc64/power6/events
/usr/share/oprofile/ppc64/power6/unit_masks
/usr/share/oprofile/ppc64/970/event_mappings
/usr/share/oprofile/ppc64/970/events
/usr/share/oprofile/ppc64/970/unit_masks
/usr/share/oprofile/ppc64/970MP/event_mappings
/usr/share/oprofile/ppc64/970MP/events
/usr/share/oprofile/ppc64/970MP/unit_masks
/usr/share/oprofile/ppc64/pa6t/event_mappings
/usr/share/oprofile/ppc64/pa6t/events
/usr/share/oprofile/ppc64/pa6t/unit_masks
/usr/share/oprofile/ppc64/power5++/event_mappings
/usr/share/oprofile/ppc64/power5++/events
/usr/share/oprofile/ppc64/power5++/unit_masks
/usr/share/oprofile/ppc64/cell-be/events
/usr/share/oprofile/ppc64/cell-be/unit_masks
/usr/share/oprofile/mips/r10000/events
/usr/share/oprofile/mips/r10000/unit_masks
/usr/share/oprofile/mips/r12000/events
/usr/share/oprofile/mips/r12000/unit_masks
/usr/share/oprofile/mips/rm7000/events
/usr/share/oprofile/mips/rm7000/unit_masks
/usr/share/oprofile/mips/rm9000/events
/usr/share/oprofile/mips/rm9000/unit_masks
/usr/share/oprofile/mips/sb1/events
/usr/share/oprofile/mips/sb1/unit_masks
/usr/share/oprofile/mips/vr5432/events
/usr/share/oprofile/mips/vr5432/unit_masks
/usr/share/oprofile/mips/vr5500/events
/usr/share/oprofile/mips/vr5500/unit_masks
/usr/share/oprofile/ppc/e500/events
/usr/share/oprofile/ppc/e500/unit_masks
/usr/share/oprofile/mips/24K/events
/usr/share/oprofile/mips/24K/unit_masks

%changelog
* Thu Jul 19 2007 Bob Nelson <rrnelson@us.ibm.com> - 0.9.3-3bsc
  Change for opcontrol.  Fix problem running on system using
  a network file system with different time base.

* Mon Jul 16 2007 Bob Nelson <rrnelson@us.ibm.com> - 0.9.3-2bsc
  Rebase on 0.9.3 code.

* Wed Jun 6 2007 Bob Nelson <rrnelson@us.ibm.com> - 0.9.2-1bsc
  Changed to a new naming convention for the oprofile package.

* Thu May 17 2007 Bob Nelson <rrnelson@us.ibm.com> - 0.9.2-0.5
  Rebase on 0.9.2 code with all of Maynard's submitted changes.
  Change m4 file for SDK build process.
  Incorporate changes for 0.9.2-0.4 into new code.

* Fri May 4 2007 Bob Nelson <rrnelson@us.ibm.com> - 0.9.2-0.4
  Add changes to allow profiling of code that the SPU runtime
  dynamically creates and runs on the stack.

